/*
**	dec.h
*/
#define	 SBLIMIT		32
#define	 SCALE			32768
#define	 CRC16_POLYNOMIAL	0x8005
#define	 MPEG_AUDIO_ID	  	1
#define	 MPG_MD_JOINT_STEREO    1
#define	 MPG_MD_MONO		3

typedef unsigned char	Uc;
typedef unsigned short	Us;
typedef unsigned int	Ui;

#ifdef IPFB
typedef int sb_sp,dctt;
#ifdef LPFB
typedef long long tv;
#else
typedef int tv;
#endif
#else
typedef float sb_sp,dctt,tv;
#endif
typedef int Sample;		// int sample

typedef unsigned char al_table[SBLIMIT][16];

typedef struct {
	Uc version;
	Uc lay;
	Uc error_protection;
	Uc bitrate_index;
	Uc sampling_frequency;
	Uc padding;
	Uc extension;
	Uc mode;
	Uc mode_ext;
	Uc copyright;
	Uc original;
	Uc emphasis;
} layer, *the_layer;

typedef struct {
	layer		*header;	/* raw header information */
	Uc		actual_mode;	/* when writing IS, may forget if 0 chs */
	al_table	*alloc;		/* bit allocation table read in */
	Uc		tab_num;	/* number of table as loaded */
	Uc		stereo;		/* 1 for mono, 2 for stereo */
	Uc		jsbound;	/* first band of joint stereo coding */
	Uc		sblimit;	/* total number of sub bands */
} frame_params;

#ifdef AUDIO
extern void	awrite(char*,int);
extern void	open_audio(int,int,int);
#endif
extern void	s_err(int);
extern void	au_out_sample(Sample*);		// output 32 samples (64 word)
extern int	getc1(void);			// input one byte from stream
extern void	au_frame_info(int,int,int);	// audio frame information
extern void	dec_frame(frame_params*);	// decoder stream
